Bug 123973 - Master objects in a LO Draw document export with TIFF but not PNG or GIF when exported with transparency
Summary: Master objects in a LO Draw document export with TIFF but not PNG or GIF when...
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Draw (show other bugs)
Version:
(earliest affected)
5.0.6.3 release
Hardware: x86-64 (AMD64) All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: bibisected, bisected, regression
: 139160 (view as bug list)
Depends on:
Blocks: Graphics-Export
  Show dependency treegraph
 
Reported: 2019-03-09 21:51 UTC by xordevoreaux
Modified: 2022-05-19 12:12 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
Export this file's slide as a PNG (10.16 KB, application/vnd.oasis.opendocument.graphics)
2019-03-11 19:30 UTC, xordevoreaux
Details
backtrace (4.16 KB, application/gzip)
2019-04-04 01:47 UTC, Regis Perdreau
Details
sample file (90.26 KB, application/vnd.oasis.opendocument.graphics)
2022-01-28 14:00 UTC, xordevoreaux
Details
output from page 1 of sample file (147.86 KB, image/png)
2022-01-28 14:01 UTC, xordevoreaux
Details

Note You need to log in before you can comment on or make changes to this bug.
Description xordevoreaux 2019-03-09 21:51:52 UTC
Description:
Placing objects on the master slide of a draw document export when exporting a slide as a TIFF but not as a PNG or GIF.  I did not test other export formats.

All export formats should be capable of exporting objects on the master.

Steps to Reproduce:
1. Create a new LO Draw document
2. Go to the master slide
3. Add an object. Text, picture, doesn't matter
4. Go to the normal slide (View-->Normal). 
5. Add stuff.
6. Export the page as PNG or GIF

Actual Results:
Anything placed on the master page does not export with PNG or GIF.

Expected Results:
Regardless of export format, all objects on the master page should export.


Reproducible: Always


User Profile Reset: No



Additional Info:
Worked fine when exporting to TIFF, failed with PNG and GIF.  
I work exclusively with PNG exports so I'm hoping this gets addressed.
Comment 1 Durgapriyanka 2019-03-11 16:26:39 UTC
Thank you for reporting the bug.I cannot reproduce this in

Version: 6.3.0.0.alpha0+
Build ID: b6b28931435e44aca92b8c0e1659f701e3ed1a87
CPU threads: 2; OS: Windows 6.1; UI render: default; VCL: win; 
TinderBox: Win-x86@42, Branch:master, Time: 2019-01-30_06:57:04
Locale: en-US (en_US); UI-Language: en-US
Calc: threaded
Comment 2 xordevoreaux 2019-03-11 19:30:27 UTC
Created attachment 149893 [details]
Export this file's slide as a PNG

Export the slide on this file as a PNG, then again as a GIF.  
The first line of text, being on the master, does not export.
Comment 3 Roman Kuznetsov 2019-03-13 14:35:50 UTC
confirm in

Version: 6.3.0.0.alpha0+ (x64)
Build ID: 13a260f59e421f3e67845f8f2eb22b8f0f8fcaf0
CPU threads: 4; OS: Windows 10.0; UI render: GL; VCL: win; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2019-03-11_02:46:09
Locale: ru-RU (ru_RU); UI-Language: en-US
Calc: threaded

and in

Версия: 5.0.6.3
ID сборки: 490fc03b25318460cfc54456516ea2519c11d1aa
Локаль: ru-RU (ru_RU)

but not in

LO 4.4.7

Regression
Comment 4 Regis Perdreau 2019-04-04 01:47:29 UTC
Created attachment 150519 [details]
backtrace

Backtrace in version Version: 6.3.0.0.alpha0+
Crash when export
Comment 5 Buovjaga 2019-04-09 19:31:18 UTC
Bibisected with win32-5.2 to https://gerrit.libreoffice.org/plugins/gitiles/core/+/f3ff67d3c3047de3ad43f8bb3f805d82eaef0479%5E!
tdf#96922 Suppress EditView PageVisuailsation in GraphicExporter

Adding Cc: to Armin Le Grand
Comment 6 xordevoreaux 2019-10-15 15:14:46 UTC
Still an issue in 6.3.3.1 win64 bit pro no GL.
Comment 7 xordevoreaux 2020-05-31 04:27:20 UTC
Retested. Still an issue with Beta 7.0.0.0

Version: 7.0.0.0.beta1 (x64)
Build ID: 94f789cbb33335b4a511c319542c7bdc31ff3b3c
CPU threads: 8; OS: Windows 10.0 Build 19635; UI render: Skia/Raster; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: threaded
Comment 8 xordevoreaux 2020-09-11 13:20:26 UTC
Still an issue in:

Version: 7.1.0.0.alpha0+ (x64)
Build ID: ed4f610f4a3de12016f8308a17b6ad4f86e9d67a
CPU threads: 8; OS: Windows 10.0 Build 20211; UI render: default; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL

And if all objects are only on the master, nowhere else, not only will PNG not export them, but you get a "filter not found" message as if you're exporting nothing (I can log that separately).
Comment 9 xordevoreaux 2020-11-23 17:13:47 UTC
Still a problem in 7.2.0.0 alpha 0

Version: 7.2.0.0.alpha0+ (x64)
Build ID: f313e27fb7f2d42247407e26e16f264e30f87ca5
CPU threads: 8; OS: Windows 10.0 Build 20262; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: threaded
Comment 10 xordevoreaux 2020-12-04 13:30:48 UTC
Still a problem in 

Version: 7.2.0.0.alpha0+ (x64)
Build ID: 561e5559bb68242c7f785f0ca3bee3eb12b58963
CPU threads: 8; OS: Windows 10.0 Build 20270; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: threaded


after the master objects options were removed.
Comment 11 Roman Kuznetsov 2020-12-30 11:12:50 UTC
*** Bug 139160 has been marked as a duplicate of this bug. ***
Comment 13 xordevoreaux 2021-03-22 18:28:08 UTC
Still a problem in 

Version: 7.2.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 07996bcca53939af02921a3d4681c6c7d62a0e40
CPU threads: 8; OS: Windows 10.0 Build 19042; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL
Comment 14 xordevoreaux 2021-05-25 02:59:38 UTC
Still a problem in

Version: 7.2.0.0.alpha1 (x64) / LibreOffice Community
Build ID: 94c1521be4ef12f195d08413d5e2134e07a49f85
CPU threads: 8; OS: Windows 10.0 Build 19042; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL
Comment 15 xordevoreaux 2021-07-06 11:06:45 UTC
Contents of master pages will show only if, upon exporting a PNG, the transparency option is cleared on the export option dialogue.
Comment 16 xordevoreaux 2021-09-10 02:22:53 UTC
Still a problem in:

Version: 7.3.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: c7b5e6566d9b24a0a996c739a945004d9aadee2f
CPU threads: 8; OS: Windows 10.0 Build 19043; UI render: Skia/Raster; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL
Comment 17 xordevoreaux 2021-12-03 16:34:34 UTC
Still a problem in 

Version: 7.3.0.0.beta1 (x64) / LibreOffice Community
Build ID: 436f14c25ec1847646b953cf13d0db4f7ca3be57
CPU threads: 8; OS: Windows 10.0 Build 19044; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL
Comment 18 xordevoreaux 2022-01-25 00:11:37 UTC
Still a problem in:
Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 86a9c860410351125708543c1050bfc0977d3b97
CPU threads: 8; OS: Windows 10.0 Build 19044; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL
Comment 19 Armin Le Grand 2022-01-25 14:36:44 UTC
Took a look. Problem is the old fix of tdf#96922 which seems no longer needed as-is. But one after the other...
Diff between TIFF working and others not working is that in GraphicExporter::GetGraphic two versions get triggered. TIFF uses Bitmap, !rSettings.mbTranslucent and lines after 652 while others which need transparency use lines after 711 that do record to a metafile and create a BitmapEx (as needed).
The diff is that 2nd contains call to
                pView->SetPagePaintingAllowed(false);
what was the fix from mentioned tdf#96922. Problem is that that mechanism not only  suppresses all view-only visualizations, but also the visit of the PageHierarchy of a possible MasterPage - which leads to this error here.

Note: Using a Metafile could be changed to sth better nowadays, e.g. use Primitives directly. That would increase quality/presicion widely, but too much work for now.

Checked that without that old fix this task is fixed. Also checked that old task tdf#96922 is also fixed nowadays another way and that we get the transparency in gif/png as needed.

So I would suggest to fix by removing old fix. Doing some more tests, though...
Comment 20 Armin Le Grand 2022-01-25 14:43:58 UTC
Ah, one more note: Another good argument for removing that old fix is that it is used only in one of those possible Bitmap-preparations of GraphicExporter::GetGraphic. If it would really be needed it would have to be done for both versions - or none, as I do now.
This leads to the note that in principle one of these versions could be removed for cleanup - the one creating the BitmapEx result can always be used to create the Bitmap result, too.
Comment 21 Commit Notification 2022-01-26 08:47:30 UTC
Armin Le Grand (Allotropia) committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/87866def6bfe2ee91be34a5ce37b79d6da881617

tdf#123973 fix missing MasterPage content in export

It will be available in 7.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 22 Commit Notification 2022-01-26 13:40:03 UTC
Armin Le Grand (Allotropia) committed a patch related to this issue.
It has been pushed to "libreoffice-7-3":

https://git.libreoffice.org/core/commit/377f1e407897e59a3452e95082eb0d80abd07ed3

tdf#123973 fix missing MasterPage content in export

It will be available in 7.3.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 23 xordevoreaux 2022-01-28 00:43:33 UTC
tdf#123973 was listed in build #904 but that build failed, as did #905 and #906, so I was waiting for a successful build to download. Glad you were able to check it.
Comment 24 Buovjaga 2022-01-28 07:50:31 UTC
(In reply to xordevoreaux from comment #23)
> tdf#123973 was listed in build #904 but that build failed, as did #905 and
> #906, so I was waiting for a successful build to download. Glad you were
> able to check it.

Hmm, not sure what those numbers are you are talking about, but you can use Win-x86_64@tb77-TDF from https://dev-builds.libreoffice.org/daily/master/current.html to test
Comment 25 xordevoreaux 2022-01-28 11:32:18 UTC
(In reply to Buovjaga from comment #24)
> (In reply to xordevoreaux from comment #23)
> > tdf#123973 was listed in build #904 but that build failed, as did #905 and
> > #906, so I was waiting for a successful build to download. Glad you were
> > able to check it.
> 
> Hmm, not sure what those numbers are you are talking about, but you can use
> Win-x86_64@tb77-TDF from
> https://dev-builds.libreoffice.org/daily/master/current.html to test

I usually look here first
https://ci.libreoffice.org/job/lo_daily_tb_win/ 
to see which build actually lists the TDF in question that needs to be retested, rather than download a version in which it has not been patched to yet, and noticed that TDF#123973 was listed under build #904, but 904 was red, meaning a failed build. 

Build 905 eventually also failed. When I looked again, 906 was in progress, but its progress spinner was spinning red, not green, so I figured that build was also in the middle of failing and stopped looking, but it eventually succeeded, but had not yet by the time I replied.
Comment 26 xordevoreaux 2022-01-28 13:59:19 UTC
Still a problem in:

Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 86a9c860410351125708543c1050bfc0977d3b97
CPU threads: 8; OS: Windows 10.0 Build 19044; UI render: Skia/Vulkan; VCL: win
Locale: en-US (en_US); UI: en-US
Calc: CL

I will attach both a new sample file and sample output shortly.

Please output page 1 of the attached draw file as a PNG with transparency selected.
Comment 27 xordevoreaux 2022-01-28 14:00:17 UTC
Created attachment 177877 [details]
sample file

Export page 1 of this file as a PNG with transparency. 
Please note this is in Windows.
Comment 28 xordevoreaux 2022-01-28 14:01:26 UTC
Created attachment 177878 [details]
output from page 1 of sample file

Notice the arrow points to nothing.  That's because the circle beneath the arrow is on the master page and does not output on a PNG when transparency is selected.
Comment 29 Buovjaga 2022-01-28 14:04:05 UTC
(In reply to xordevoreaux from comment #26)
> Still a problem in:
> 
> Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
> Build ID: 86a9c860410351125708543c1050bfc0977d3b97
> CPU threads: 8; OS: Windows 10.0 Build 19044; UI render: Skia/Vulkan; VCL:
> win
> Locale: en-US (en_US); UI: en-US
> Calc: CL
> 
> I will attach both a new sample file and sample output shortly.
> 
> Please output page 1 of the attached draw file as a PNG with transparency
> selected.

Why are you using this old build? It is from 24 Jan while the fix landed on 26 Jan. Setting back to fixed until proven otherwise.
Comment 30 xordevoreaux 2022-01-28 14:10:12 UTC
(In reply to Buovjaga from comment #29)
> (In reply to xordevoreaux from comment #26)
> > Still a problem in:
> > 
> > Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
> > Build ID: 86a9c860410351125708543c1050bfc0977d3b97
> > CPU threads: 8; OS: Windows 10.0 Build 19044; UI render: Skia/Vulkan; VCL:
> > win
> > Locale: en-US (en_US); UI: en-US
> > Calc: CL
> > 
> > I will attach both a new sample file and sample output shortly.
> > 
> > Please output page 1 of the attached draw file as a PNG with transparency
> > selected.
> 
> Why are you using this old build? It is from 24 Jan while the fix landed on
> 26 Jan. Setting back to fixed until proven otherwise.

That was the build I downloaded this morning dated the 28th from https://dev-builds.libreoffice.org/daily/master/current.html

I can wait for yet another  build.
Comment 31 Buovjaga 2022-01-28 16:40:30 UTC
(In reply to xordevoreaux from comment #30)
> (In reply to Buovjaga from comment #29)
> > Why are you using this old build? It is from 24 Jan while the fix landed on
> > 26 Jan. Setting back to fixed until proven otherwise.
> 
> That was the build I downloaded this morning dated the 28th from
> https://dev-builds.libreoffice.org/daily/master/current.html
> 
> I can wait for yet another  build.

Then you must have accidentally launched some older installer, because I just now installed that one from 28th and its last commit is not 86a9c860410351125708543c1050bfc0977d3b97 from 23 Jan, but 25aecb05a9835742266d216a0be6859c835d4415 from 27 Jan.

I verify the bug is fixed.

Version: 7.4.0.0.alpha0+ (x64) / LibreOffice Community
Build ID: 25aecb05a9835742266d216a0be6859c835d4415
CPU threads: 2; OS: Windows 10.0 Build 19042; UI render: Skia/Raster; VCL: win
Locale: fi-FI (fi_FI); UI: fi-FI
Calc: threaded
Comment 32 Commit Notification 2022-01-31 19:44:23 UTC
Xisco Fauli committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/98d6ed2aeb22b27fddf716a372f483b89ecea841

tdf#123973: sd_png_export_tests: Add unittest

It will be available in 7.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 33 Commit Notification 2022-02-03 10:11:41 UTC
Xisco Fauli committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/028602a7fc0691958ade01c9bc7cd617e85203ac

tdf#147119:Revert "tdf#123973 fix missing MasterPage content in export"

It will be available in 7.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 34 Xisco Faulí 2022-02-03 10:13:40 UTC
The commit has been reverted, reopening
Comment 35 Armin Le Grand 2022-02-04 08:51:38 UTC
@Xisco, @Buovjaga. Thanks for you help here, much appreciated!

Note to myself: This caused unwanted side-effect of tdf#147119, probably due to exporting the PageBackground (aka 'wiese' in former days). Need to find a way to deactivate PagePainting (tat means to supress all stuff like PageBounds, inner PB, Grid, Wiese, heklplines, etc..., but *without* supressing the MasterPage content and thus it's ShapeHierarchy. That's the key to fixing it...
Comment 36 Commit Notification 2022-02-04 11:13:13 UTC
Xisco Fauli committed a patch related to this issue.
It has been pushed to "libreoffice-7-3":

https://git.libreoffice.org/core/commit/7d9851c65c33865b995932e0d83cee815edcbbce

tdf#147119:Revert "tdf#123973 fix missing MasterPage content in export"

It will be available in 7.3.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 37 Gabor Kelemen (allotropia) 2022-02-17 13:15:05 UTC Comment hidden (no-value)
Comment 38 Armin Le Grand 2022-05-13 08:53:33 UTC
Back to new - no timeslots currenly. To keep in sight, tagging in PersonalTags